*:*********************************************************************
*:
*:        Program: POPCALC.PRG
*:
*:         System: MIS Consulting
*:         Author: Charles Alan Butler  CIS 72251,633
*:      Copyright (c) 1990, Charles Alan Butler
*:  Last modified: 03/25/90      8:50
*:
*:  Procs & Fncts: CALC_ON
*:               : REGSAY
*:               : REGINC
*:
*:          Calls: CALC_ON        (procedure in POPCALC.PRG)
*:               : REGSAY         (procedure in POPCALC.PRG)
*:               : REGINC         (procedure in POPCALC.PRG)
*:
*:      Documented 03/25/90 at 08:55                SNAP!  version 4.02
*:*********************************************************************

PARAMETERS WinRow,WinCol,RtnType
** -- Window Row & Col, Return Type
*  RtnType --------  Return Action  -----
*  ''            RETURN only
*  'STUFF'       Stuff the keyboard with Register 1
*  'FUNCTION'    RETURN <Register 1> as a number

** -- Save some of the calling environment
PopSch1=SCHEME(1)  &&  SAVE Colors   [FoxPro]
PopSch2=SCHEME(2)  &&  SAVE Colors   [FoxPro]
SaveDec=SYS(2001,'DECIMALS')   &&  save decimal setting

DEFINE WINDOW PopCalc FROM WinRow,WinCol TO WinRow+17,WinCol+23 NONE
ACTIVATE WINDOW PopCalc

**  --  Set up local variables
cWidth=16                      &&  register width
cDec=2                         &&  Decimals allowed
SET DECIMALS TO 2
cReg  = SPACE(cWidth)          &&  Register 1
icReg = SPACE(cWidth)          &&  Register 1 for Inches
RegPict=REPLICATE('9',cWidth-cDec-1)+'.'+REPLICATE('9',cDec)
Reg2  = 0                      &&  Register 2
Reg3  = 0                      &&  Register 3
iReg2 = 0                      &&  Register 2 for inches
iReg3 = 0                      &&  Register 3 for inches
cMem  = 0                      &&  Memory Register
icMem = 0                      &&  Memory Register
STORE '+' TO Oper1,Oper2,Oper3 &&  Math function symbol
Ky=0                           &&  Key stroke

cColor='W+/R'                  &&  Register color
MsgColor='rb+/b'               &&  Message Color
cClear=.F.

**  - NOTE: Feet & Inches processes are not complete at this time
cFeet=.F.         &&  Feet & Inches Flags
cInches=.F.
iWidth=7
Ky2=0          &&  Memory Operations Key
MemPtr=1       &&  Array Pointer for window
DIMENSION aReg(10)  &&  Memory Array
aReg = 0       &&  Fill array

DO Calc_On        &&  Display the calculator

DO WHILE .T.
   
   DO RegSay         &&  Display registers
   
   DO WHILE .T.
      Ky=INKEY(0,'HM')          &&  get KEY COMMAND  ******************
      IF Ky=151   &&   Mouse Clicked  =================================
         IF MROW()>=0.AND.MCOL()>=0   &&  In window, so decode
            DO CASE
            CASE MROW()=WROWS()-1
               Ky=72       &&  Help
            CASE MROW()=0 .AND. MCOL()=0
               Ky=27       &&  ESC
            CASE MROW()=7   && Mcl STO RCL x^y CLR
               Ky=ASC(SUBSTR(' MMM TTT RRR ^^^ CCC  ',MCOL(),1))
            CASE MROW()=9
               Ky=ASC(SUBSTR(' 777 888 999 /// SSS  ',MCOL(),1))
            CASE MROW()=11
               Ky=ASC(SUBSTR(' 444 555 666 *** %%%  ',MCOL(),1))
            CASE MROW()=13
               Ky=ASC(SUBSTR(' 111 222 333 --- EEE  ',MCOL(),1))
            CASE MROW()=15
               Ky=ASC(SUBSTR(' 000 ... III +++ ===  ',MCOL(),1))
            ENDCASE
            IF Ky#151 .AND. Ky#32      &&  mouse was decoded
               EXIT
            ENDIF
         ENDIF
      ELSE     &&  key was pressed
         EXIT
      ENDIF
   ENDDO
   
   @ 6,2 SAY SPACE(19)    &&  Clear message area
   
   **  --  Test for Mem display scroll
   IF Ky=5       &&  Up
      MemPtr = IIF(MemPtr=1,10,MemPtr-1)
      LOOP
   ENDIF
   IF Ky=24      &&  Down
      MemPtr = IIF(MemPtr=10,1,MemPtr+1)
      LOOP
   ENDIF
   
   IF ky2#0      &&  Memory Operation Was Iniated
      DO CASE
      CASE Ky2=84 .AND. BETWEEN(Ky,48,57)      &&  Store to Array
         aReg(Ky-47) = (VAL(cReg)+VAL(icReg)/12)
         MemPtr=Ky-47
         Ky2=0
         
      CASE Ky2=84 .AND. (Ky=43 .OR. Ky=139)    &&  [+]  Add Operation
         SET COLOR TO &MsgColor
         @ 6,2 SAY '[  Add to Mem 0-9  ]'
         Ky2=43
         
      CASE Ky2=84 .AND. (Ky=45 .OR. Ky=147)    &&  [-]  Subtract Operation
         SET COLOR TO &MsgColor
         @ 6,2 SAY '[ Sub from Mem 0-9 ]'
         Ky2=45
         
      CASE Ky2=82 .AND. BETWEEN(Ky,48,57)      &&  [Rr] Recall from Array
         cReg = STR(aReg(Ky-47),cWidth,cDec)
         MemPtr=Ky-47
         Ky2 = 0
         
      CASE Ky2=43 .AND. BETWEEN(Ky,48,57)      &&  Add Array
         aReg(Ky-47) = aReg(Ky-47) + (VAL(cReg)+VAL(icReg)/12)
         MemPtr=Ky-47
         Ky2 = 0
         
      CASE Ky2=45 .AND. BETWEEN(Ky,48,57)      &&  Subtract Array
         aReg(Ky-47) = aReg(Ky-47) - (VAL(cReg)+VAL(icReg)/12)
         MemPtr=Ky-47
         Ky2 = 0
         
      OTHERWISE
         Ky2 = 0
      ENDCASE
      LOOP
   ENDIF
   
   DO CASE
   CASE Ky=27                                         &&  [ESC]
      * ---Closing Operations.
      SET COLOR OF SCHEME 1 TO &PopSch1  &&  Restore Colors   [FoxPro]
      SET COLOR OF SCHEME 2 TO &PopSch2  &&  Restore Colors   [FoxPro]
      SET DECIMALS TO VAL(SaveDec)
      RELEASE WINDOW PopCalc
      DO CASE
      CASE RtnType = ''
         RETURN .T.
      CASE UPPER(LEFT(RtnType,3)) = 'STU'
         KEYBOARD LTRIM(cReg)
         RETURN 0
      CASE UPPER(LEFT(RtnType,3)) = 'FUN'
         RETURN VAL(cReg)
      ENDCASE
      
   CASE (Ky>47.AND.Ky<58) .OR. Ky=46                  &&  Numeric input
      IF Ky=46 .AND. (('.'$cReg.AND..NOT.cFeet).OR.'.'$icReg)
         SET COLOR TO &MsgColor
         @ 6,2 SAY '[ Decimal exist ]'
      ELSE
         IF LEN(LTRIM(cReg))>=cWidth.OR.LEN(LTRIM(icReg))>=7
            SET COLOR TO &MsgColor
            @ 6,2 SAY '[ Number too large ]'
         ENDIF
         IF cClear      &&  clear register 1 before continuing
            cClear=.F.
            Oper1=' '
            STORE SPACE(cWidth) TO cReg
            STORE SPACE(6) TO icReg
            IF cInches
               icReg=SPACE(6)+CHR(Ky)
            ELSE
               cReg=SPACE(cWidth-1)+CHR(Ky)
            ENDIF cInches
         ELSE     &&  add keystorke to register 1
            IF cInches
               icReg=RIGHT(icReg+CHR(Ky),7)
            ELSE
               cReg=RIGHT(cReg+CHR(Ky),cWidth)
            ENDIF cInches
         ENDIF
      ENDIF
      LOOP
      
   CASE Ky=8 .OR. Ky=127 .OR. Ky=19             &&  [BS] [Del] [Left-Arrow]
      Oper1=CHR(27)
      cClear = .F.
      IF LEN(LTRIM(cReg))>=1
         IF cInches
            icReg=' '+LEFT(cReg,6)
         ELSE
            cReg=' '+LEFT(cReg,cWidth-1)
         ENDIF
      ELSE
         IF cFeet .AND. cInches
            cInches=.F.
         ELSE
            cReg=STR(Reg2,cWidth,IIF(Reg2=INT(Reg2),0,cDec))
            icReg=STR(iReg2,cWidth,IIF(iReg2=INT(iReg2),0,cDec))
            Reg2=Reg3
            iReg2=iReg3
            Oper2=Oper3
            Reg3=0
            iReg3=0
            Oper3='+'
         ENDIF
      ENDIF
      LOOP
      
   CASE Ky=61 .OR. Ky=13                              &&  [=] or [ENTER]
      IF cFeet .AND. Ky=13 .AND. .NOT. cInches
         Oper1='I'
         cInches=.T.
      ELSE
         Oper1='='
         cReg=STR((Reg3+iReg3/12) &Oper3 (Reg2+iReg2/12) &Oper2 (VAL(cReg)+VAL(icReg)/12),cWidth,cDec)
         IF cFeet
            icReg=STR((VAL(cReg)-INT(VAL(cReg)))*12,7,3)
            cReg=STR(INT(VAL(cReg)),cWidth)
         ENDIF
         STORE 0 TO Reg2,Reg3,iReg2,iReg3
         STORE '+' TO Oper2,Oper3
         cClear=.T.
         cInches=.F.
      ENDIF
      
   CASE Ky=67 .OR. Ky=99                              &&  [Cc]  Clear
      Oper1='C'
      cClear = .F.
      STORE SPACE(cWidth) TO cReg,icReg
      STORE 0 TO Reg2,Reg3,iReg2,iReg3
      STORE '+' TO Oper2,Oper3
      cInches=.F.
      
   CASE Ky=69 .OR. Ky=101                             &&  [Ee]  Clear Entry
      STORE SPACE(cWidth) TO cReg,icReg      &&  Clear Register 1 Only
      
   CASE Ky=70 .OR. Ky=102                             &&  [Ff]  Feet Toggle
      Oper1='F'
      cInches=.F.
      cFeet=IIF(cFeet,.F.,.T.)
      cWidth=IIF(cFeet,8,16)
      cDec=IIF(cFeet,3,2)
      STORE SPACE(cWidth) TO cReg,icReg
      STORE 0 TO Reg2,Reg3,iReg2,iReg3
      STORE '+' TO Oper1,Oper2,Oper3
      SET COLOR TO RB+/B
      @ 2,4 TO 4,20 CLEAR
      @ 2,8 SAY 'F         I'
      @ 3,8 SAY 'F         I'
      @ 3,8 SAY 'F         I'
      SET COLOR TO &cColor
      
   CASE Ky=83 .OR. Ky=115                             &&  [Ss]  Square Root
      Oper1=CHR(251)
      Reg2=SQRT(ABS((Reg3+iReg3/12) &Oper3 (Reg2+iReg2/12) &Oper2 (VAL(cReg)+VAL(icReg)/12)))
      STORE SPACE(cWidth) TO cReg,icReg
      STORE 0 TO Reg3
      STORE '+' TO Oper2,Oper3
      cClear = .T.
      
   CASE Ky=68 .OR. Ky=100                             &&  [Dd] Decimal Change
      IF cFeet
         SET COLOR TO &MsgColor
         @ 6,2 SAY '[  Decimals  Fixed  ]'
      ELSE
         Oper1='D'
         Ky=INKEY(0)
         IF Ky>48.AND.Ky<58) && 1 - 9 only
            cDec=Ky-48
            SET DECIMALS TO cDec
         ENDIF
         RegPict=REPLICATE('9',cWidth-cDec-1)+'.'+REPLICATE('9',cDec)
      ENDIF cFeet
      
   CASE Ky=42.OR.Ky=43.OR.Ky=45.OR.Ky=47.OR.Ky=94
      **  *       +        -        /        ^
      Oper1=CHR(Ky)
      DO RegInc
      
   CASE Ky=37                                         &&  [%]  Percent
      **  get the percentage
      cReg=STR((Reg2+iReg2/12) * ((VAL(cReg)+VAL(icReg)/12)/100),cWidth,cDec)
      icReg=SPACE(cWidth)
      IF cFeet
         **  debug
      ENDIF
      cReg=STR((Reg3+iReg3/12) &Oper3 (Reg2+iReg2/12) &Oper2 (VAL(cReg)+VAL(icReg)/12),cWidth,cDec)
      STORE 0 TO Reg2,Reg3
      STORE '%' TO Oper1
      STORE '+' TO Oper2,Oper3
      cClear = .T.
      
   CASE Ky=73 .OR. Ky=105                            &&  [Ii] Inverse Register 1
      cReg=STR(-(VAL(cReg)+VAL(icReg)/12),cWidth,cDec)
      
   CASE Ky=76 .OR. Ky=108                            &&  [Ll] List Memory
      SET COLOR TO GR+/N
      @ 2,1,13,21 BOX 'Ŀ '
      @ 2,3 SAY '[  Memory  List  ]'
      FOR i = 1 TO 10
         @ i+2,2 SAY 'M'+STR(i-1,1)
         @ i+2,5 SAY aReg(i) PICTURE RegPict
      ENDFOR
      @ i+2,3 SAY '[ Press Any Key ]'
      Ky=INKEY(0)
      DO Calc_On
      
   CASE Ky=77 .OR. Ky=109                            &&  [Mm] Memory Clear
      STORE 0 TO aReg
      
   CASE Ky=82 .OR. Ky=114 .OR. Ky=84 .OR. Ky=116  &&  [Rr] Recall [Tt] sTore
      SET COLOR TO &MsgColor
      IF Ky=82 .OR. Ky=114   &&  [Rr] Recall
         @ 6,2 SAY '[   Enter  0-9    ]'
         Ky2=82
      ENDIF
      IF  Ky=84 .OR. Ky=116 [Tt] STORE
         @ 6,2 SAY '[  Enter 0-9 + -  ]'
         Ky2=84
      ENDIF
      
   CASE Ky=28 .OR. Ky=72 .OR. Ky=104                  &&  [F1] [Hh]  Help
      DEFINE WINDOW calhelp FROM 2,10 TO 20,60  ;
         TITLE '[  HELP WINDOW  ]' DOUBLE COLOR G+/N,RB+/N,RB+/N
      ACTIVATE WINDOW calhelp
      @ ROW(),2 SAY '----KEY----------ACTION--------------------'
      @ ROW()+1,2 SAY '  [ESC]    Exit calculator.'
      @ ROW()+1,2 SAY '  [0 - 9]  Enter numbers.'
      @ ROW()+1,2 SAY '  [C]      Clear registers 1-3.'
      @ ROW()+1,2 SAY '  [E]      Clear Entry registers 1 only.'
      @ ROW()+1,2 SAY '  [M]      Clear ALL Memory Registers.'
      @ ROW()+1,2 SAY '  [R]      Recall the Memory Register.'
      @ ROW()+1,2 SAY '  [T]+[+]  Add to a Memory Register.'
      @ ROW()+1,2 SAY '  [T]+[-]  Subtract from a Memory Register.'
      @ ROW()+1,2 SAY '  [L]      List all Memory Registers.'
      @ ROW()+1,2 SAY '  [Arrow]  Up/Down = scroll Memory Registers.'
      @ ROW()+1,2 SAY '  [S] []  Square root.'
      @ ROW()+1,2 SAY '  [I] []  Inverse of register 1.'
      @ ROW()+1,2 SAY '  [^][y^x] Raise y to the x power.'
      @ ROW()+1,2 SAY '  [D]      Set the number of decimals.'
      * @ ROW()+1,2 SAY '  [F]      Toggle the Feet/Inches Calculator.'
      @ ROW()+1,2 SAY '  [F1] [H] Displays this screen.'
      @ ROW()+1,2 SAY '       <  Press Key To Return  >'
      keycode=INKEY(0,'HM')
      RELEASE windows calhelp
      
   ENDCASE
   
ENDDO  while .T.

*!*********************************************************************
*!
*!      Procedure: REGSAY
*!
*!      Called by: POPCALC.PRG                   
*!
*!*********************************************************************
PROCEDURE RegSay        &&  Display registers
SET COLOR TO &cColor
IF cFeet
   @ 4,4 SAY VAL(cReg) PICTURE '9999'
   @ 4,10 SAY VAL(icReg) PICTURE '9999.999'
   SET COLOR TO &MsgColor
   @ 2,4 SAY Reg3 PICTURE '9999'
   @ 3,4 SAY Reg2 PICTURE '9999'
   @ 2,10 SAY iReg3 PICTURE '9999.999'
   @ 3,10 SAY iReg2 PICTURE '9999.999'
ELSE
   @ 4,4 SAY VAL(cReg) PICTURE RegPict
   SET COLOR TO &MsgColor
   @ 1,3 SAY MemPtr-1 PICTURE '9'
   @ 1,4 SAY aReg(MemPtr) PICTURE RegPict
   @ 2,4 SAY Reg3 PICTURE RegPict
   @ 3,4 SAY Reg2 PICTURE RegPict
ENDIF cFeet
@ 2,21 SAY Oper3 PICTURE 'X'
@ 3,21 SAY Oper2 PICTURE 'X'
@ 4,21 SAY Oper1 PICTURE 'X'
RETURN

*!*********************************************************************
*!
*!      Procedure: REGINC
*!
*!      Called by: POPCALC.PRG                   
*!
*!*********************************************************************
PROCEDURE RegInc        &&   preform operations  [+-/*]

cClear = .F.
IF Oper1$'+-'
   Reg2=(Reg3+iReg3/12) &Oper3 (Reg2+iReg2/12) &Oper2 (VAL(cReg)+VAL(icReg)/12)
   Reg3=0
   Oper3 = '+'
ELSE
   IF Oper2$'+-'
      Reg3=Reg2
      iReg3=iReg2
      Oper3=Oper2
      Reg2=VAL(cReg)
      iReg2=VAL(icReg)
   ELSE
      Reg2=(Reg2+iReg2/12) &Oper2 (VAL(cReg)+VAL(icReg)/12)
   ENDIF
ENDIF
STORE SPACE(cWidth) TO cReg,icReg
Oper2=Oper1
Oper1=' '
cInches=.F.

IF cFeet
   iReg2=(Reg2-INT(Reg2))*12
   Reg2=INT(Reg2)
   iReg3=(Reg3-INT(Reg3))*12
   Reg3=INT(Reg3)
ENDIF cFeet

RETURN

*!*********************************************************************
*!
*!      Procedure: CALC_ON
*!
*!      Called by: POPCALC.PRG                   
*!
*!*********************************************************************
PROCEDURE Calc_On
SET COLOR TO W+/B        &&  Calculator color
@ 0 ,0 SAY ''
@ 1 ,0 SAY ' M                   '
@ 2 ,0 SAY ' R3                  '
@ 3 ,0 SAY ' R2                  '
@ 4 ,0 SAY ' R1                  '
@ 5 ,0 SAY ''
@ 6 ,0 SAY '                     '
@ 7 ,0 SAY ' Mcl sTO RCL x^y CLR '
@ 8 ,0 SAY '                     '
@ 9 ,0 SAY ' (7) (8) (9) (/) () '
@ 10,0 SAY '                     '
@ 11,0 SAY ' (4) (5) (6) (*) (%) '
@ 12,0 SAY '                     '
@ 13,0 SAY ' (1) (2) (3) (-) (E) '
@ 14,0 SAY '                     '
@ 15,0 SAY ' (0) (.) () (+) (=) '
@ 16,0 SAY '                     '
@ 17,0 SAY ''
SET COLOR TO GR+/R
@ 0 ,0 SAY CHR(254)
@ 0 ,7 SAY 'Calculator'
@ 17,7 SAY '[F1=Help]'
SET COLOR TO &cColor
RETURN
*: EOF: POPCALC.PRG
